/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);

//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
std::vector<VISA_opnd*> RTRWOperandsVec;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 142 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_VERSION = 13,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 14,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 15,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 16,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 17,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 18,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 19,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 20,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 21,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 22,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 23,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 24,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 25,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 26,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 27,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 28,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 29,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 31,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 32,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 33,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 34,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 35,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 36,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 37,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 38,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 39,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 40,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 41,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 42,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 43,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_BFTYPE = 51,                    /* BFTYPE  */
  YYSYMBOL_VTYPE = 52,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 53,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 54,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 55,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 56,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 57,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 58,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 59,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 60,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 61,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 62,                    /* RBRACE  */
  YYSYMBOL_DOT = 63,                       /* DOT  */
  YYSYMBOL_COMMA = 64,                     /* COMMA  */
  YYSYMBOL_SEMI = 65,                      /* SEMI  */
  YYSYMBOL_COLON = 66,                     /* COLON  */
  YYSYMBOL_SLASH = 67,                     /* SLASH  */
  YYSYMBOL_PERCENT = 68,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 69,                    /* EQUALS  */
  YYSYMBOL_PLUS = 70,                      /* PLUS  */
  YYSYMBOL_MINUS = 71,                     /* MINUS  */
  YYSYMBOL_TIMES = 72,                     /* TIMES  */
  YYSYMBOL_AMP = 73,                       /* AMP  */
  YYSYMBOL_CIRC = 74,                      /* CIRC  */
  YYSYMBOL_PIPE = 75,                      /* PIPE  */
  YYSYMBOL_TILDE = 76,                     /* TILDE  */
  YYSYMBOL_BANG = 77,                      /* BANG  */
  YYSYMBOL_QUESTION = 78,                  /* QUESTION  */
  YYSYMBOL_LEQ = 79,                       /* LEQ  */
  YYSYMBOL_GEQ = 80,                       /* GEQ  */
  YYSYMBOL_EQ = 81,                        /* EQ  */
  YYSYMBOL_NEQ = 82,                       /* NEQ  */
  YYSYMBOL_SHL = 83,                       /* SHL  */
  YYSYMBOL_SHRS = 84,                      /* SHRS  */
  YYSYMBOL_SHRZ = 85,                      /* SHRZ  */
  YYSYMBOL_LABEL = 86,                     /* LABEL  */
  YYSYMBOL_IDENT = 87,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 88,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 89,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 90,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 91,                   /* NEWLINE  */
  YYSYMBOL_BUILD_OPTION_LINE = 92,         /* BUILD_OPTION_LINE  */
  YYSYMBOL_UNIFORM = 93,                   /* UNIFORM  */
  YYSYMBOL_RTWRITE_OPTION = 94,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 95,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 96,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 97,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 98,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 99,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 100,                    /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 101,            /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 102,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 103,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 104,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 105,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 106,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 107,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 108,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 109,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 110,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 111,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 112,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 113,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 114,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 115,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 116,               /* ARITH4_OP2  */
  YYSYMBOL_ARITH5_OP2 = 117,               /* ARITH5_OP2  */
  YYSYMBOL_CMP_OP = 118,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 119,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 120,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 121,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 122,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 123,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 124,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 125,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 126,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 127,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 128,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 129,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 130,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 131,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 132,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 133,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 134,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 135,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 136,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 137,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 138,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 139,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 140,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 141,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 142,                   /* IFCALL  */
  YYSYMBOL_FCALL = 143,                    /* FCALL  */
  YYSYMBOL_FADDR = 144,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 145,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 146,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 147,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 148,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 149,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 150,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 151,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 152,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 153,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 154,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 155,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 156,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 157,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 158,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 159,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 160,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 161,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 162,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 163,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 164,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 165,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 166,                   /* AVS_OP  */
  YYSYMBOL_BREAKPOINT_OP = 167,            /* BREAKPOINT_OP  */
  YYSYMBOL_CALL_OP = 168,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 169,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 170,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 171,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 172,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 173,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 174,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 175, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 176,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 177,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 178,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 179,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 180, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 181, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 182,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 183,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 184,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 185,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 186,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 187,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 188,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 189,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 190,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 191,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 192, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 193, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 194,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 195, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 196, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 197,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 198, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 199,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 200,                  /* FCVT_OP  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_TYPED_BLOCK2D = 201, /* LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
  YYSYMBOL_YYACCEPT = 202,                 /* $accept  */
  YYSYMBOL_Listing = 203,                  /* Listing  */
  YYSYMBOL_ListingHeader = 204,            /* ListingHeader  */
  YYSYMBOL_Statements = 205,               /* Statements  */
  YYSYMBOL_Newlines = 206,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 207,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 208,                /* Statement  */
  YYSYMBOL_Scope = 209,                    /* Scope  */
  YYSYMBOL_ScopeStart = 210,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 211,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 212,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 213,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 214,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 215,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 216,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 217,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 218,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 219,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 220,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 221,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 222,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 223,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 224,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 225,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 226,              /* InputOffset  */
  YYSYMBOL_InputSize = 227,                /* InputSize  */
  YYSYMBOL_DirectiveAttr = 228,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 229,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 230,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 231,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 232,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 233,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 234,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 235,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 236,              /* Instruction  */
  YYSYMBOL_Label = 237,                    /* Label  */
  YYSYMBOL_LogicInstruction = 238,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 239,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 240,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 241,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 242,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 243,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 244,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 245,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 246,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 247,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 248,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 249,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 250,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 251,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 252,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 253,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 254,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 255,           /* MovInstruction  */
  YYSYMBOL_BreakpointInstruction = 256,    /* BreakpointInstruction  */
  YYSYMBOL_MovsInstruction = 257,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 258,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 259,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 260,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 261,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 262,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 263, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 264, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 265, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 266,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 267,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 268,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 269,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 270,        /* SampleInstruction  */
  YYSYMBOL_SamplerAddrOperand = 271,       /* SamplerAddrOperand  */
  YYSYMBOL_Sample3dInstruction = 272,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 273,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 274, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 275,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 276,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 277,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 278,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 279,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 280,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 281,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 282,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 283,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 284,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 285,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 286,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 287,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 288,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 289,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 290,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 291,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 292,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 293,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 294,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 295,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 296,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 297,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 298,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 299,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 300,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 301,                 /* LscFence  */
  YYSYMBOL_LscSfid = 302,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 303,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 304,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 305, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 306, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperand = 307, /* LscTypedAddrWithOffsetOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperandList = 308, /* LscTypedAddrWithOffsetOperandList  */
  YYSYMBOL_LscTypedAddrOperandWithOffsets = 309, /* LscTypedAddrOperandWithOffsets  */
  YYSYMBOL_LscAddrImmOffsetOpt = 310,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 311,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 312,          /* LscAddrModelOpt  */
  YYSYMBOL_LscAddrModelStateful = 313,     /* LscAddrModelStateful  */
  YYSYMBOL_LscVectorOpRegOrImm32 = 314,    /* LscVectorOpRegOrImm32  */
  YYSYMBOL_LscVectorOpImm32 = 315,         /* LscVectorOpImm32  */
  YYSYMBOL_LscVectorOpReg = 316,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 317,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 318,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 319,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 320,     /* LscPayloadNonNullReg  */
  YYSYMBOL_LscInstructionXe2 = 321,        /* LscInstructionXe2  */
  YYSYMBOL_LscTypedBlock2dLoad = 322,      /* LscTypedBlock2dLoad  */
  YYSYMBOL_LscTypedBlock2dStore = 323,     /* LscTypedBlock2dStore  */
  YYSYMBOL_LscTypedBlock2dAddrOperand = 324, /* LscTypedBlock2dAddrOperand  */
  YYSYMBOL_LscDataOperandTyped2D = 325,    /* LscDataOperandTyped2D  */
  YYSYMBOL_LscUntypedApndCtrAtomic = 326,  /* LscUntypedApndCtrAtomic  */
  YYSYMBOL_SwitchLabels = 327,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 328,        /* BranchInstruction  */
  YYSYMBOL_FILE = 329,                     /* FILE  */
  YYSYMBOL_LOC = 330,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 331,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 332,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 333,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 334,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 335,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 336,            /* OwordModifier  */
  YYSYMBOL_Predicate = 337,                /* Predicate  */
  YYSYMBOL_PredSign = 338,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 339,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 340,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 341,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 342,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 343,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 344,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 345,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 346, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 347,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 348,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 349,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 350,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 351,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 352,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 353,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 354,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 355,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 356,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 357,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 358,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 359,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 360,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 361,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 362,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 363,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 364,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 365,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 366,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 367,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 368,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 369,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 370,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 371,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 372,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 373,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 374,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 375,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 376,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 377,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 378,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 379,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 380,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 381,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 382,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 383,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 384,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 385,              /* ExecSizeInt  */
  YYSYMBOL_Var = 386,                      /* Var  */
  YYSYMBOL_VarNonNull = 387,               /* VarNonNull  */
  YYSYMBOL_IntExp = 388,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 389,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 390,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 391,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 392,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 393,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 394,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 395,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 396,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 397,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 398,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 399,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 400,               /* IntExpPrim  */
  YYSYMBOL_DataType = 401,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 402,      /* DataTypeIntOrVector  */
  YYSYMBOL_BuildOptions = 403              /* BuildOptions  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3331

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  202
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  202
/* YYNRULES -- Number of rules.  */
#define YYNRULES  463
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1187

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   456


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   671,   671,   676,   678,   678,   680,   680,   681,   681,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   699,   700,   701,   705,   709,   712,   712,   719,   727,
     735,   742,   743,   744,   745,   746,   747,   749,   756,   764,
     772,   779,   783,   783,   786,   794,   799,   811,   818,   826,
     826,   827,   833,   837,   841,   845,   850,   856,   856,   858,
     862,   868,   876,   882,   887,   892,   898,   902,   906,   912,
     917,   923,   927,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   990,   994,  1000,  1005,  1011,
    1018,  1024,  1031,  1038,  1045,  1052,  1062,  1071,  1078,  1085,
    1094,  1104,  1110,  1117,  1123,  1132,  1142,  1149,  1156,  1164,
    1173,  1180,  1187,  1193,  1199,  1205,  1211,  1229,  1236,  1246,
    1254,  1261,  1268,  1277,  1286,  1295,  1303,  1306,  1309,  1312,
    1315,  1318,  1323,  1330,  1338,  1339,  1345,  1358,  1366,  1373,
    1378,  1383,  1400,  1400,  1402,  1402,  1405,  1422,  1440,  1440,
    1443,  1451,  1459,  1462,  1466,  1472,  1485,  1485,  1489,  1497,
    1509,  1525,  1531,  1544,  1552,  1559,  1567,  1573,  1579,  1585,
    1591,  1598,  1599,  1608,  1609,  1610,  1612,  1613,  1614,  1616,
    1619,  1620,  1621,  1622,  1624,  1651,  1683,  1713,  1741,  1767,
    1795,  1824,  1858,  1902,  1947,  1983,  2022,  2027,  2027,  2030,
    2031,  2035,  2044,  2050,  2059,  2079,  2099,  2119,  2139,  2146,
    2150,  2153,  2158,  2161,  2166,  2172,  2180,  2193,  2194,  2195,
    2200,  2201,  2204,  2205,  2206,  2207,  2211,  2214,  2217,  2220,
    2223,  2226,  2231,  2231,  2235,  2245,  2253,  2261,  2275,  2279,
    2285,  2290,  2293,  2297,  2300,  2306,  2308,  2309,  2321,  2350,
    2372,  2384,  2395,  2404,  2426,  2429,  2432,  2439,  2443,  2447,
    2451,  2457,  2462,  2469,  2476,  2481,  2486,  2492,  2499,  2506,
    2512,  2518,  2526,  2534,  2542,  2552,  2557,  2562,  2567,  2572,
    2577,  2582,  2587,  2592,  2592,  2598,  2603,  2608,  2608,  2610,
    2610,  2613,  2613,  2616,  2617,  2618,  2619,  2621,  2621,  2626,
    2627,  2629,  2630,  2634,  2635,  2638,  2639,  2642,  2643,  2644,
    2647,  2648,  2651,  2652,  2653,  2656,  2657,  2660,  2661,  2663,
    2665,  2675,  2682,  2690,  2698,  2717,  2729,  2736,  2748,  2753,
    2760,  2765,  2773,  2781,  2787,  2792,  2814,  2818,  2824,  2834,
    2842,  2849,  2859,  2865,  2872,  2876,  2881,  2885,  2891,  2892,
    2899,  2907,  2908,  2914,  2924,  2932,  2941,  2959,  2973,  2976,
    2987,  2998,  3003,  3008,  3016,  3025,  3037,  3051,  3053,  3064,
    3076,  3082,  3090,  3099,  3099,  3100,  3100,  3103,  3105,  3106,
    3108,  3109,  3111,  3112,  3114,  3115,  3117,  3118,  3119,  3121,
    3122,  3123,  3124,  3125,  3144,  3147,  3148,  3149,  3150,  3152,
    3153,  3154,  3156,  3157,  3162,  3167,  3169,  3170,  3171,  3172,
    3176,  3177,  3179,  3183,  3187,  3193,  3202,  3203,  3204,  3205,
    3206,  3208,  3209,  3212
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ", "ATTR_EQ", "OFFSET_EQ",
  "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ", "V_TYPE_EQ_G", "V_TYPE_EQ_P",
  "V_TYPE_EQ_A", "V_TYPE_EQ_S", "V_TYPE_EQ_T", "CPS",
  "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK", "RAW_SEND_STRING",
  "RAW_SENDC_STRING", "RAW_SENDS_STRING", "RAW_SENDS_EOT_STRING",
  "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING", "SAT", "SRCMOD_ABS",
  "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP", "DPAS_OP",
  "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL", "NBARRIER_WAIT",
  "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "BFTYPE",
  "VTYPE", "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK",
  "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA",
  "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES",
  "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ",
  "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL",
  "BUILTIN", "STRING_LIT", "NEWLINE", "BUILD_OPTION_LINE", "UNIFORM",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "ARITH5_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "BREAKPOINT_OP",
  "CALL_OP", "PRED_CNTL", "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT",
  "BUILTIN_SIZEOF", "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP",
  "LSC_CACHING_OPT", "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK",
  "LSC_DATA_SHAPE_TK_CHMASK", "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT",
  "LSC_AM_BTI", "LSC_AM_BSS", "LSC_AM_SS", "LSC_AM_ARG",
  "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE", "LSC_SFID_UNTYPED_TOKEN",
  "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC", "LSC_LOAD_STRIDED_MNEMONIC",
  "LSC_LOAD_BLOCK2D_MNEMONIC", "LSC_STORE_MNEMONIC",
  "LSC_STORE_STRIDED_MNEMONIC", "LSC_STORE_BLOCK2D_MNEMONIC",
  "LSC_ATOMIC_MNEMONIC", "LSC_READ_STATE_INFO_MNEMONIC",
  "LSC_FENCE_MNEMONIC", "FCVT_OP", "LSC_DATA_SHAPE_TK_TYPED_BLOCK2D",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveAttr", "DirectiveFunc", "AlignAttrOpt", "Align",
  "AliasAttrOpt", "OneAttr", "AttrOpt", "GenAttrOpt", "Instruction",
  "Label", "LogicInstruction", "UnaryLogicInstruction",
  "MathInstruction_2OPND", "MathInstruction_3OPND",
  "ArithInstruction_2OPND", "ArithInstruction_3OPND",
  "ArithInstruction_4OPND", "DpasInstruction", "BfnInstruction",
  "QwScatterInstruction", "FCvtInstruction", "AntiTrigInstruction",
  "AddrAddInstruction", "SetpInstruction", "SelInstruction",
  "MinInstruction", "MaxInstruction", "MovInstruction",
  "BreakpointInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "SamplerAddrOperand",
  "Sample3dInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Gather43dInstruction", "PixelNullMaskEnableOpt",
  "ResInfo3dInstruction", "SampleInfo3dInstruction", "RTWriteOperands",
  "RTWriteInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrWithOffsetOperand",
  "LscTypedAddrWithOffsetOperandList", "LscTypedAddrOperandWithOffsets",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscAddrModelStateful", "LscVectorOpRegOrImm32", "LscVectorOpImm32",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "LscInstructionXe2", "LscTypedBlock2dLoad",
  "LscTypedBlock2dStore", "LscTypedBlock2dAddrOperand",
  "LscDataOperandTyped2D", "LscUntypedApndCtrAtomic", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", "BuildOptions", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1076)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-451)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       7, -1076,   129,    49,   124, -1076, -1076,   -25,     7, -1076,
     108,  3052,    23,   116,   171,   111,   171,   122,   135,   171,
     142,   176,  1164,  1164,   164, -1076, -1076, -1076,   176,   190,
      64,   158,   165,   199, -1076, -1076, -1076,   186,   208,   231,
     221,   236,   171,   176,   176,   176,   224,   145, -1076,  1318,
     227,   230, -1076, -1076,   241,   256,   246,   351,   295, -1076,
    -129,   369,     7, -1076, -1076,  2675, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,  3133, -1076,
   -1076,   400, -1076, -1076, -1076, -1076, -1076,   425,   425, -1076,
     379,   -38,   263, -1076, -1076, -1076, -1076,   221,    32,   169,
      32,    32, -1076, -1076, -1076, -1076, -1076,    68,   324,   -12,
   -1076,   -24,  1164, -1076, -1076, -1076, -1076, -1076, -1076,   413,
     412, -1076,    42, -1076, -1076, -1076,   221,   221, -1076,   176,
     176,   176,  1164, -1076,   176,   412,   301,   176,   435,   397,
     328,   221,   263,  1164,   221,   -24,  1164,   221,   221, -1076,
   -1076,   221, -1076, -1076, -1076, -1076, -1076,   176,   176, -1076,
   -1076,   221, -1076, -1076,   314, -1076,   176,  2021, -1076, -1076,
    2871,   176,   176,   199,   199,   199,   199,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   176,   176,   443,   410,   411,   505,   416,   447,   418,
     512,   513,   176,   176,   -19,   176,   369,   490,   490,   490,
     426,   176,   176,   456,    89,   332,    97,   109,   333,   156,
     168,   335,   476,   508,   509,   510,   514,    32,    28,   515,
     278, -1076,   473,   470,   475,   263, -1076,   477,     9,   482,
      32, -1076, -1076,   486, -1076,    24,   462,   474, -1076,   238,
      25, -1076,   277,    17, -1076,   317, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076,   461, -1076,   413,   412,
    1164,    32, -1076,   395,    32,   500, -1076, -1076, -1076,   389,
   -1076,   393, -1076, -1076,   502,   -24,  1164,  1164,   263,   221,
     221, -1076,   158,   387,   221,   221,   501,   263,   263,   504,
     263, -1076, -1076, -1076,   516,    61,   517,   221,  1164, -1076,
     114,  1164,    -6,    -6,   221,   376,   221, -1076, -1076,     7,
   -1076,   398,   402,   199,   199,   199,   199,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   -24,   -24,   401,   176,   176,   531,   176,   423,   176,
     534,   534,   171, -1076,   176,  1164,   518,   176, -1076,   573,
     519,   520, -1076,   176,   429,   171,   430,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   346,
     589,    32,    32,    32,    32, -1076,   551,    32,   598, -1076,
   -1076, -1076, -1076, -1076,   446,   449,   263,   -31, -1076, -1076,
      32,    32, -1076,    32,    32,    32,    32,    32,    32,    32,
      32,    32,    32,    32,    32,    32,    32,    32,    32,    32,
      32,   555,   395,   500,  1164,   305,    70, -1076, -1076, -1076,
   -1076, -1076, -1076,   559,    32, -1076, -1076,   564,   221, -1076,
    1227, -1076, -1076,   563, -1076, -1076,   566,    32,  1164,  1164,
      61,   263,   263, -1076,  1164,  1293,   221,   567,   346,   221,
     457,   263,   263,  1164,   263,    32,   395, -1076,   516,    -9,
   -1076,   569, -1076, -1076,   572,    32, -1076,   221,   263, -1076,
     263,  1164, -1076,  1318,   570,   463,   464,   199,   199,   199,
     199,   -24,   -24,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
     -24,   -24,   -24,   -24,   -24,   -24,   221,   571,  1164,  1164,
     465,   176,   221,   176,   221,   466,   176,   176, -1076,  1164,
     467,   468,   -24, -1076,   606,   176,   176,   221,   469, -1076,
     176,   480,   176,   176,   176,   176,   346,   176,   176,   176,
     176,   279,   176,   176,   475,   279, -1076, -1076,   477,    32,
     598,   598,   623,   623,   556, -1076, -1076,   584, -1076,   221,
      32, -1076,   590,   586,   462,    46,   474, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076,    17,    17,   308,   308,   308, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076,   478,    32,    32,    32,
     587, -1076, -1076, -1076, -1076, -1076, -1076,    32,    32,   591,
    1164,  1164, -1076, -1076,   263,   255,  1164,  1164,  1164, -1076,
     263,   263,  1164,   593,   263, -1076,   594,   263,   604, -1076,
   -1076,    -9,    -9,   601,    32,    32,    -2,   600,   263, -1076,
    1164, -1076, -1076,   493,   494,   199,   199,   176,   176,  1164,
    1164,   221,  1164,   221,  1164,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1164,   495,   263,   263,
   -1076,   263,   263,   221,  1164, -1076,   221,   221,   497,   498,
     499,  1075,  1075,   130, -1076,   565,  1164,  1164, -1076,   263,
     221, -1076,   346,   346,   346,   346,   471,   279,   274,   279,
     274,   492,   616,   617,   618,   624,   346,   346,   346,   625,
     664, -1076, -1076,   595,   598,   598,   614, -1076,   126, -1076,
   -1076,   412,   626, -1076, -1076,    32,   629,   621,   631,   632,
     136,   651, -1076, -1076, -1076,  1164,   263,   263,   263,   263,
    1164, -1076,   263,  1164, -1076, -1076, -1076, -1076, -1076,   650,
     172, -1076,   151, -1076,  1164,  1318,  1318,   176,   176,  1318,
    1318,  1164, -1076, -1076,  1164,   221,  1164,  1164,  1164,  1164,
    1164, -1076, -1076,  1164, -1076,  1164,  1164,  1164,  1164,   176,
     263,   263,   263,   263,  1164,   263,   263,   263,   539, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,   566,   176,
      -6,    -6,  1382,   263,   263,   274,   207,   279,   274,   492,
     532, -1076, -1076, -1076, -1076,   346,   658, -1076,   346,   659,
   -1076,   346,   660,   662,   346,    77,    77,    77,    77, -1076,
     274,   279,   128,    51,   705, -1076, -1076, -1076, -1076,   378,
   -1076,   556, -1076, -1076, -1076, -1076,    32, -1076, -1076,    32,
     263, -1076,   263,   263,   263,  1164,   263,   661, -1076,   663,
    1164,   263,   263,  1318,  1318,  1318,  1318,  1164, -1076, -1076,
    1164,  1164, -1076, -1076, -1076, -1076, -1076,  1164, -1076, -1076,
     263, -1076, -1076,   263,   263,   263,   263,   263,   263, -1076,
    1164,   263,    -6, -1076, -1076,   263,   263, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076,   151, -1076,   128, -1076,   151,
     221, -1076,   178, -1076, -1076,   115, -1076,   184,   193,   656,
     325,   346,   346,   346,   665, -1076,   477, -1076, -1076, -1076,
   -1076,   672,   598, -1076, -1076, -1076,   673,   689, -1076, -1076,
   -1076,   263,  1164,   263, -1076, -1076,  1164,   263,   263,  1318,
    1318,   263,   263, -1076, -1076,  1164, -1076,   263,   263,   263,
     263, -1076,   263,   263,    -6,   263,   263,   263, -1076,   128,
     674,   681,   690,   399,   128,    91, -1076,    32,    32,   576,
   -1076,    32, -1076,    32,    32,    32,    32,   686,   346, -1076,
     346, -1076,    44, -1076, -1076, -1076, -1076,   263, -1076,  1164,
   -1076, -1076,   263,   263,   263,   263, -1076, -1076, -1076,   263,
   -1076,   263,   263,    -6, -1076,   263, -1076,   325, -1076,   128,
     577,    32,    32,   325,    77,   692,   694,   696, -1076,   701,
     702,   699,   308,    17,   221, -1076, -1076, -1076,   700, -1076,
    1164,   263,   263,   263,   263, -1076, -1076,   263,   263,   263,
   -1076,   706,   703, -1076,    17,    17,    54,   708,    32, -1076,
      32, -1076, -1076, -1076,   325,    32,   675,   263,   263, -1076,
   -1076,   263,   263, -1076,   263,   596,   128,    77,    77,   712,
     717,   722,   710,  1164, -1076, -1076,   263, -1076, -1076,   716,
     728,   723,    32, -1076, -1076, -1076,   687, -1076,   263,   128,
     611,    77,   730,  1164, -1076, -1076,   727,   736,   263,    77,
   -1076, -1076,   731,   325,    77,   732,   737,   325,    77, -1076,
     740,   741,   325, -1076, -1076,   743, -1076
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   325,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   327,    24,   125,   463,     0,   337,
       0,   323,     0,     0,   166,   167,   168,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   315,     0,
     318,   320,   322,   317,     0,     0,     0,     0,     0,   153,
       0,   331,     8,     5,    19,     0,    11,    12,    10,    36,
      31,    32,    33,    34,    35,    14,    13,    16,    15,    17,
      18,    73,    75,    76,    77,    78,    79,    80,   118,   119,
     120,   122,    81,    82,   103,   100,   101,   102,    99,   124,
      98,    83,    84,    86,    87,    89,    88,    90,    92,    93,
      95,    94,   108,   109,   110,   111,   112,   113,   114,    97,
      96,    85,    74,   121,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   123,   286,   287,   285,
      91,   104,   105,   106,   115,   116,   107,   117,     0,    20,
      30,     0,    26,    27,    56,    37,    29,    49,    49,    28,
      54,     0,     0,   334,   333,   335,   336,     0,     0,     0,
       0,     0,   415,   414,   416,   388,   391,   450,   451,     0,
     455,     0,     0,   347,   359,   349,   384,   386,   348,     0,
       0,   413,     0,   449,   171,   328,     0,     0,   338,     0,
       0,     0,     0,   324,     0,     0,     0,     0,   407,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   305,
     306,     0,   316,   350,   351,   319,   321,     0,     0,   309,
     310,     0,   237,   238,     0,   332,     0,   325,     2,    23,
     325,     0,     0,     0,     0,     0,     0,   331,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   331,
     331,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   331,   188,   188,   188,
     196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,    46,
      55,   412,     0,     0,     0,     0,   365,     0,     0,     0,
       0,   450,   451,     0,   417,   419,   421,   423,   425,   428,
     433,   434,   438,   441,   445,   451,   385,   387,   446,   447,
     448,   392,   389,   393,   390,   383,     0,   453,     0,     0,
     170,     0,   398,     0,     0,     0,   461,   462,   382,   329,
     404,     0,   339,   372,     0,     0,     0,     0,     0,     0,
       0,   409,   323,     0,     0,     0,     0,     0,     0,     0,
       0,   304,   341,   342,     0,     0,     0,     0,     0,   340,
       0,     0,     0,     0,     0,     0,     0,     4,    25,     8,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,     0,     0,     0,
     174,   174,     0,   299,     0,     0,     0,     0,   189,   182,
       0,     0,   197,     0,     0,     0,     0,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,     0,
       0,     0,     0,     0,     0,    50,     0,     0,    71,    48,
      45,    52,    53,   410,     0,     0,     0,     0,   367,   402,
       0,     0,   452,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   433,   457,   458,   459,
     460,   394,   456,     0,     0,   380,   330,     0,     0,   357,
       0,   355,   358,   376,   356,   379,     0,     0,     0,     0,
     404,     0,     0,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   374,     0,   294,
     155,     0,   156,   154,     0,     0,   146,     0,     0,   179,
       0,     0,   236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   297,     0,
       0,     0,     0,   183,   184,     0,     0,     0,     0,   298,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   414,     0,   281,   282,   413,     0,
      71,    71,    42,    42,     0,    51,    47,     0,   366,     0,
       0,   368,     0,     0,   420,     0,   422,   424,   426,   427,
     429,   430,   431,   432,   439,   440,   435,   436,   437,   443,
     444,   442,   454,   395,   381,   169,     0,     0,   400,     0,
       0,   326,   378,   145,   352,   354,   353,     0,     0,     0,
       0,     0,   204,   205,     0,   161,     0,     0,     0,   408,
       0,     0,     0,     0,     0,   201,     0,     0,     0,   375,
     373,   294,   294,     0,     0,     0,     0,     0,     0,   191,
       0,   143,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     212,     0,     0,     0,     0,   175,     0,     0,     0,     0,
       0,     0,     0,     0,   185,     0,     0,     0,   192,     0,
       0,   240,     0,     0,     0,     0,     0,     0,   262,     0,
     262,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,    40,    39,     0,    71,    71,    68,    70,     0,   411,
     140,     0,     0,   401,   405,     0,     0,     0,     0,     0,
       0,     0,   158,   157,   203,     0,     0,     0,     0,     0,
       0,   361,     0,     0,   202,   396,   295,   296,   300,     0,
       0,   364,     0,   190,     0,     0,     0,     0,     0,     0,
       0,     0,   130,   131,     0,     0,     0,     0,     0,     0,
       0,   144,   132,     0,   134,     0,     0,     0,   136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   302,
     301,   151,   343,   345,   344,   346,   150,   152,   404,     0,
       0,     0,   195,     0,     0,   262,     0,     0,   262,     0,
       0,   292,   288,   263,   264,     0,     0,   265,     0,     0,
     243,     0,     0,     0,     0,     0,     0,     0,     0,   289,
     262,     0,     0,     0,    63,    58,    43,    41,    44,     0,
      72,     0,   360,   369,   418,   399,     0,   403,   377,     0,
       0,   160,     0,     0,     0,     0,     0,     0,   363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   126,   127,
       0,     0,   147,   148,   149,   133,   135,     0,   138,   139,
       0,   209,   210,     0,     0,     0,     0,     0,     0,   303,
       0,     0,     0,   193,   194,     0,     0,   225,   278,   279,
     232,   226,   227,   280,   228,   260,   233,     0,   229,   260,
       0,   230,     0,   273,   272,   275,   274,     0,     0,     0,
     257,     0,   265,     0,     0,   283,   284,    62,    59,    60,
      61,     0,    71,    67,    66,    69,     0,     0,   159,   162,
     178,     0,     0,     0,   362,   180,     0,     0,     0,     0,
       0,     0,     0,   141,   128,     0,   137,     0,     0,     0,
       0,   164,     0,     0,     0,     0,     0,     0,   142,     0,
       0,   252,     0,   249,     0,     0,   270,     0,     0,     0,
     266,     0,   268,     0,     0,     0,     0,     0,     0,   293,
       0,   235,     0,    38,   397,   406,   177,     0,   200,     0,
     307,   308,     0,     0,     0,     0,   129,   207,   208,     0,
     165,     0,     0,     0,   370,     0,   198,   257,   261,     0,
       0,     0,     0,   257,     0,     0,     0,     0,   276,     0,
       0,     0,   258,   259,     0,   231,   234,    65,     0,   176,
       0,     0,     0,     0,     0,   163,   172,     0,     0,   186,
     370,     0,   253,   256,   250,   251,     0,     0,     0,   271,
       0,   267,   269,   290,   257,     0,     0,     0,     0,   313,
     314,     0,     0,   371,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   311,   312,     0,   370,   241,   254,
       0,     0,     0,   277,   291,    64,     0,   173,   181,     0,
       0,     0,     0,     0,   255,   242,     0,     0,     0,     0,
     248,   199,     0,   257,     0,     0,     0,   257,     0,   245,
       0,     0,   257,   246,   247,     0,   244
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1076, -1076, -1076,   561,   -53,    31,   575, -1076, -1076,   249,
       4, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
     187, -1076, -1076, -1076,   666,   521, -1076, -1076, -1076, -1076,
   -1076,   -92, -1076,  -445, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076,   396, -1076, -1076,  -356,
   -1076, -1076, -1076, -1076, -1076,   198, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076, -1076,
   -1076,    45,  -744,   -50,   -48, -1041, -1076,  -824, -1047,  -150,
    -729,  -578,  -845,  -872,  -878,  -667,   -61,  -444,  -871, -1076,
   -1076, -1076,    69,    59, -1076,  -213, -1076, -1076, -1076, -1076,
   -1076, -1076, -1076, -1076,   472, -1076, -1076, -1076,   483,    50,
   -1076,   235,   442,  -298,    87, -1076,   -22,  -535, -1076, -1076,
   -1076,   110, -1076, -1076, -1076,   452, -1076,  1405,  -877, -1076,
   -1075, -1076,  -193, -1076,  -325, -1076,   481, -1076,   120,   667,
     668, -1076,  -371,  -323,   506,  -156,  -188,  -199, -1076,  -195,
   -1076,  -175,  2341,   367,    16,   840,   842,    48,   365,   370,
     371,   364,    21,  -337, -1076,  -479,  -472,   538,  -783,  -460,
     653, -1076
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    62,     3,     4,    63,    64,    65,   390,
     154,    66,    67,     9,    68,    69,    70,    71,    72,    73,
     774,    74,    75,    76,   298,   458,    77,    78,   894,   895,
     992,   777,   778,   459,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   676,   103,
     104,   105,   106,   107,   108,   109,   586,   110,   111,   548,
     112,   594,   745,   113,   114,   429,   115,   116,   862,   117,
     433,   118,   119,   120,   121,   122,   581,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     234,   602,   880,   881,   884,  1031,  1032,   878,  1047,  1029,
     876,   877,   972,   973,   974,   865,   869,   866,  1033,   136,
     137,   138,   766,   757,   139,   693,   140,   141,   142,   143,
     144,   145,   146,   147,   204,   148,   196,   507,   236,   181,
     199,   351,   377,   371,   851,   852,   853,   222,   663,   509,
     510,   183,   780,   211,   214,   540,   378,   616,   306,   468,
    1109,   352,   372,   373,   854,   513,   855,   184,   185,   186,
     187,   188,   537,   342,   343,   189,   345,   349,   308,   515,
     364,   207,   162,   302,   190,   191,   976,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   192,   193,   501,
     502,   149
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     182,   194,   353,   536,   496,   615,   646,   647,   648,   237,
     980,   644,   645,   626,   875,   985,   979,   360,   701,   381,
     156,   984,   505,   159,   379,   338,   512,   550,   630,   919,
    1111,   882,   653,   765,   167,  1134,  1116,   769,  1112,    11,
     161,   977,   978,   960,   456,  1097,   215,   336,   457,   172,
     173,   174,   987,   547,   988,   691,   212,   518,   811,   374,
     232,   233,   659,   172,   173,   174,   469,   983,   393,   394,
     395,   396,  1158,   470,   424,   337,   689,  1141,   692,   479,
     480,   172,   173,   174,   488,   489,   867,   868,   346,   490,
     985,   168,  1035,   238,   347,  1149,   240,   473,     1,   221,
     890,   891,   474,   310,   481,   482,   200,   201,   170,   171,
     168,  1135,   785,   575,   576,   535,   331,   332,  1137,   473,
     344,   957,   310,   161,   479,   658,  1175,   170,   171,     5,
    1180,   172,   173,   174,   301,  1185,   168,     7,   989,   882,
       6,   631,   640,   641,   642,   643,   981,    10,   310,   481,
     482,   493,   985,   170,   171,  1084,   519,   985,  1077,   223,
     340,  1085,   756,  1083,   172,   173,   174,   690,   535,   224,
     654,    12,  1091,   545,  1038,   771,   772,   303,  1039,   765,
     358,   879,  1030,   309,   535,   665,  1030,   538,   900,   668,
     901,   369,   538,   379,   376,   150,   791,   339,   688,   374,
     659,   155,   985,   151,   311,   312,   179,   180,   964,   157,
     168,   966,   350,   354,   968,   172,  1124,   174,   557,   558,
     559,   560,   158,   311,   312,   179,   180,   367,   168,   160,
     370,   375,   918,   380,   350,   161,   659,   339,  1036,  1117,
     310,   195,  1037,   198,  1040,   170,   171,   384,  1041,   311,
     312,   179,   180,  1042,   203,   374,   374,  1043,   152,   985,
     205,   153,   206,   709,   710,   712,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   437,   438,
     921,   922,   985,   208,   925,   926,   440,   441,  1164,   879,
     210,  1173,  1150,  1151,   742,   213,  1177,  1172,   442,   443,
    1182,  -450,  1176,   331,   332,   209,  1181,  -450,   172,   173,
     174,   870,   982,   879,   219,  1049,  1166,   220,   494,   477,
     478,   641,   756,   311,   312,   179,   180,   953,   225,   897,
     898,   226,   538,   229,   521,   522,   237,   168,   227,   175,
     176,   177,   325,   179,   180,   445,   446,   483,   484,   310,
     172,   304,   174,   228,   170,   171,   542,   447,   448,   546,
     485,   486,   487,   711,   713,   333,   334,   516,   461,   656,
     657,   520,   333,   334,   335,   524,   525,   726,   483,   484,
     528,   529,   705,   706,   707,   708,   958,   959,  1009,  1010,
    1011,  1012,   231,   541,   544,  1045,  1046,   353,   549,   549,
     551,   221,   375,   590,   235,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     554,   292,   293,   294,   295,   296,   588,   375,   375,   163,
     164,   165,   166,   172,   614,   174,   374,   168,   230,   599,
     870,   346,   297,   497,   498,   499,   500,   347,   300,   310,
     311,   312,   179,   180,   170,   171,   873,   762,   763,   764,
     874,   511,   762,   763,   764,   617,   508,   341,   993,  1081,
    1082,   344,   655,   361,  1062,  1063,   430,   431,   806,   807,
     172,   173,   174,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   363,   365,   670,   671,   638,   639,
     366,   385,   674,   677,   951,   952,   413,   414,   415,   416,
     418,   686,   823,   417,   825,   419,   420,   421,   428,   436,
     432,   439,   444,   450,   662,   449,   451,   452,   453,   700,
     817,   818,   454,   463,   464,   457,   475,  1048,   465,  1050,
     467,   471,   678,   857,   681,   682,   472,  1053,   491,   476,
     311,   312,   179,   180,   504,   538,   728,   729,   506,   527,
     221,   517,   994,   697,   552,   530,  1092,   738,   533,   996,
     535,   555,   997,   577,  1093,   556,   539,   375,   520,   520,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     375,   375,   350,   902,   580,   583,  1026,   585,   732,   593,
     734,   598,   600,   221,  1095,   591,  1096,   619,   743,  1114,
    1115,   601,   624,   748,   456,   652,   595,   596,   301,   667,
     664,   628,   617,   659,   661,   668,   929,   679,   694,   683,
     666,   695,   388,   744,   727,   703,   704,   730,   735,   739,
     740,   749,   773,   776,   779,   781,   784,   783,   792,   793,
     786,   791,   657,   801,   795,   796,   797,   751,   803,   805,
     800,   808,   859,   223,   812,   815,   816,   839,  1073,   848,
     849,   850,   871,   224,   883,   885,   886,   887,   814,   893,
     888,   892,   896,   899,   905,   906,   903,   821,   822,   908,
     824,   907,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   837,   838,   909,   324,   328,   329,   330,
     918,   949,   845,   963,   965,   967,   969,  1108,   970,   991,
    1044,  1004,  1051,  1005,   860,   861,  1052,   350,  1054,   350,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,  1055,  1079,  1078,  1080,  1088,   844,
    1094,  1118,   846,   847,  1119,  1113,  1123,   516,   858,   427,
    1120,  1121,  1122,  1135,  1125,  1155,   864,  1136,   617,   617,
     617,   617,  1138,   910,  1148,  1143,  1152,  1153,   915,  1154,
    1159,   917,   617,   617,   617,  1160,  1163,  1161,  1142,  1165,
    1167,  1169,   920,  1170,  1179,  1174,  1178,  1183,  1184,   927,
    1186,   389,   928,   702,   930,   931,   932,   933,   934,   995,
     775,   935,   387,   936,   937,   938,   939,   587,   961,  1034,
     460,   962,   945,   971,   299,   889,   872,   741,   553,   856,
     543,   627,   514,   904,   526,   324,   326,   327,   324,   635,
     637,   350,     0,   634,   492,   348,   636,     0,   328,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   221,   221,     0,     0,   221,
     221,     0,     0,     0,     0,     0,   549,   549,     0,   324,
       0,     0,   324,     0,     0,     0,     0,     0,     0,     0,
       0,   617,     0,  1002,   617,     0,     0,   617,  1006,     0,
     617,   975,   975,   975,   975,  1013,     0,     0,  1014,  1015,
       0,     0,   221,     0,     0,  1016,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   223,   223,     0,  1024,   223,
     223,     0,     0,     0,     0,   224,   224,     0,     0,   224,
     224,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   549,     0,
       0,     0,   223,   221,   221,   221,   221,     0,     0,     0,
    1057,     0,   224,     0,  1059,     0,   975,     0,     0,   324,
     324,   324,   324,  1066,     0,   324,     0,   617,   617,   617,
       0,     0,   307,     0,     0,     0,     0,     0,   324,   324,
     313,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   649,   650,   651,     0,
       0,     0,     0,   223,   223,   223,   223,  1100,     0,     0,
     549,     0,   324,   224,   224,   224,   224,     0,     0,     0,
       0,     0,   307,     0,     0,   324,     0,     0,     0,   221,
     221,     0,     0,     0,   617,     0,   617,     0,  1098,     0,
       0,     0,     0,   324,     0,     0,     0,     0,  1126,     0,
       0,     0,     0,   324,     0,     0,     0,     0,     0,   549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,   163,   164,   165,   166,     0,     0,     0,     0,   223,
     223,  1156,     0,     0,     0,     0,     0,     0,     0,   224,
     224,     0,     0,   167,   168,     0,     0,     0,     0,   455,
       0,  1168,   462,     0,     0,   307,   169,     0,   508,     0,
       0,   170,   171,   975,   975,     0,     0,   324,     0,     0,
       0,     0,   172,   173,   174,     0,     0,     0,   324,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,   495,     0,   975,   503,     0,     0,     0,
     975,     0,     0,     0,   975,   324,   324,   324,   307,     0,
     163,   164,   165,   166,     0,   324,   324,   307,   307,     0,
     307,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   167,   168,     0,     0,     0,     0,     0,     0,
       0,     0,   324,   324,     0,   169,     0,     0,     0,     0,
     170,   171,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   172,   173,   174,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   163,   164,   165,   166,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   168,     0,     0,   618,
       0,     0,     0,   620,   621,   622,   623,     0,   169,   625,
     508,     0,     0,   170,   171,     0,   307,     0,     0,     0,
       0,     0,   632,   633,   172,   173,   174,     0,     0,     0,
       0,     0,     0,   324,     0,     0,     0,     0,     0,   163,
     164,   165,   166,     0,   175,   176,   177,   178,   179,   180,
       0,     0,     0,     0,     0,     0,   660,     0,     0,     0,
       0,   167,   168,     0,   163,   164,   165,   166,     0,   669,
       0,   307,   307,     0,   169,     0,     0,     0,   618,   170,
     171,   307,   307,     0,   307,     0,     0,   168,     0,     0,
     172,   173,   174,     0,     0,     0,     0,   696,   307,   169,
     307,     0,     0,     0,   170,   171,     0,   175,   176,   177,
     178,   179,   180,     0,     0,   172,   173,   174,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   163,   164,
     165,   166,     0,   324,   324,   324,   324,     0,     0,     0,
       0,   324,     0,     0,     0,     0,     0,   324,     0,     0,
       0,   168,     0,     0,   324,     0,   618,   324,     0,     0,
       0,     0,     0,   169,     0,     0,     0,     0,   170,   171,
       0,   770,     0,   175,   176,   675,   178,   179,   180,   172,
     614,   174,   782,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   175,   176,
     177,   178,   179,   180,     0,     0,     0,     0,     0,   787,
       0,   788,     0,     0,     0,     0,     0,     0,     0,   789,
     790,     0,     0,     0,   307,     0,     0,     0,     0,     0,
     307,   307,     0,     0,   307,     0,     0,   307,     0,     0,
       0,     0,     0,     0,     0,     0,   809,   810,   307,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   305,   307,   307,
       0,   307,   307,     0,     0,   324,   324,     0,     0,   324,
       0,   324,   324,   324,   324,     0,     0,     0,     0,   307,
       0,     0,   618,   618,   618,   618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   618,   618,   618,     0,
       0,     0,     0,     0,     0,     0,     0,   368,     0,   324,
     324,     0,   324,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   307,   307,   307,   307,
       0,     0,   307,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1139,     0,   324,     0,
       0,     0,     0,   324,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   324,   324,     0,     0,     0,
     307,   307,   307,   307,     0,   307,   307,   307,     0,     0,
    1162,     0,     0,     0,     0,     0,     0,     0,     0,   324,
       0,     0,   618,   307,   307,     0,     0,   324,     0,     0,
     466,     0,   324,     0,     0,   618,   324,     0,   618,     0,
       0,   618,     0,     0,   618,     0,     0,     0,     0,     0,
       0,     0,   986,     0,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     307,     0,   307,   307,   307,     0,   307,     0,     0,     0,
       0,   307,   307,   523,     0,     0,     0,     0,     0,     0,
       0,     0,   531,   532,     0,   534,     0,     0,     0,     0,
     307,     0,     0,   307,   307,   307,   307,   307,   307,     0,
       0,   307,     0,     0,     0,   307,   307,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   986,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   618,   618,   618,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   307,     0,   307,     0,     0,     0,   307,   307,     0,
       0,   307,   307,     0,     0,     0,     0,   307,   307,   307,
     307,     0,   307,   307,     0,   307,   307,   307,     0,   986,
       0,   629,     0,     0,   986,     0,     0,     0,     0,  1086,
    1087,     0,     0,  1089,     0,  1090,     0,     0,   618,     0,
     618,     0,     0,     0,     0,     0,     0,   307,     0,     0,
       0,     0,   307,   307,   307,   307,     0,     0,     0,   307,
       0,   307,   307,     0,     0,   307,     0,     0,     0,   986,
       0,     0,     0,     0,     0,     0,   672,   673,     0,     0,
       0,     0,     0,   680,     0,     0,   684,   685,     0,   687,
       0,   307,   307,   307,   307,     0,     0,   307,   307,   307,
       0,     0,     0,   698,     0,   699,     0,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,   307,   307,     0,
       0,   307,   307,     0,   307,     0,   986,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   307,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   307,   986,
       0,     0,     0,     0,     0,     0,     0,     0,   307,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -9,     0,     0,     0,     0,    13,    14,    15,    16,
      17,    18,    19,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,    22,    23,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   794,
      24,     0,    25,    -9,     0,   798,   799,     0,     0,   802,
       0,     0,   804,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   813,     0,     0,     0,    26,     0,     0,
       0,     0,     6,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   840,   841,     0,   842,   843,     0,    29,
      30,     0,     0,     0,     0,    31,    32,    33,     0,     0,
       0,    34,    35,    36,   863,     0,    37,    38,    39,    40,
      41,     0,     0,     0,     0,    42,    43,    44,    45,     0,
      46,    47,    48,    49,    50,    51,    52,    53,     0,     0,
       0,    54,    55,     0,     0,    56,    57,    58,    59,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   911,   912,   913,   914,     0,     0,   916,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   941,   942,   943,   944,     0,
     946,   947,   948,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,   955,   956,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   998,     0,   999,  1000,  1001,
       0,  1003,     0,     0,     0,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1017,     0,     0,  1018,  1019,
    1020,  1021,  1022,  1023,     0,     0,  1025,     0,     0,     0,
    1027,  1028,     0,     0,     0,     0,     0,     0,     0,   197,
       0,   202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   216,   217,   218,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1056,     0,  1058,     0,
       0,     0,  1060,  1061,     0,     0,  1064,  1065,     0,     0,
       0,     0,  1067,  1068,  1069,  1070,     0,  1071,  1072,     0,
    1074,  1075,  1076,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1099,     0,     0,     0,     0,  1101,  1102,  1103,
    1104,     0,     0,     0,  1105,     0,  1106,  1107,     0,     0,
    1110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1127,  1128,  1129,  1130,
       0,     0,  1131,  1132,  1133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1144,  1145,     0,     0,  1146,  1147,     0,  1133,
     355,   356,   357,     0,     0,   359,     0,     0,   362,     0,
       0,  1157,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1133,     0,     0,     0,     0,   382,   383,
       0,     0,     0,  1171,     0,     0,     0,   386,     0,     0,
       0,     0,   391,   392,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   411,   412,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   422,   423,   425,   426,     0,     0,     0,
       0,     0,   434,   435,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   239,     0,     0,     0,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,    -8,    -8,     0,     0,    -8,
      -8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    -8,     0,    -8,    -8,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,     0,     0,   578,   579,     0,   582,     0,
     584,    -8,     0,     0,     0,   589,     1,    -8,   592,     0,
       0,     0,     0,     0,   597,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,     0,
       0,    -8,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    13,    14,    15,    16,
      17,    18,    19,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,    22,    23,     0,     0,     0,
       0,     0,   731,     0,   733,     0,     0,   736,   737,     0,
      24,     0,    25,   388,     0,     0,   746,   747,     0,     0,
       0,   750,     0,   752,   753,   754,   755,     0,   758,   759,
     760,   761,     0,   767,   768,     0,     0,    26,     0,     0,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
      30,     0,     0,     0,     0,    31,    32,    33,     0,     0,
       0,    34,    35,    36,     0,     0,    37,    38,    39,    40,
      41,     0,     0,     0,     0,    42,    43,    44,    45,     0,
      46,    47,    48,    49,    50,    51,    52,    53,     0,     0,
       0,    54,    55,     0,     0,    56,    57,    58,    59,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   819,   820,
       0,     0,     0,     0,     0,     0,     0,    13,    14,    15,
      16,    17,    18,    19,    20,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,     0,    22,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,    25,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,   923,   924,
       0,     0,   241,   242,   243,   244,   245,   246,     0,     0,
      29,    30,     0,   247,     0,     0,    31,    32,    33,     0,
     940,     0,    34,    35,    36,     0,     0,    37,    38,    39,
      40,    41,     0,     0,     0,     0,    42,    43,    44,    45,
     950,    46,    47,    48,    49,    50,    51,    52,    53,     0,
       0,     0,    54,    55,     0,     0,    56,    57,    58,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,    60,    61,   263,   264,   265,   266,     0,     0,     0,
     267,   268,   269,     0,     0,     0,   270,   271,     0,     0,
       0,     0,     0,   272,   273,   274,   275,     0,     0,     0,
       0,   276,     0,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,     0,     0,   280,   281,     0,     0,     0,
       0,   282,     0,     0,     0,     0,     0,     0,     0,   283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   284,   285,   286,   287,   288,   289,
     290,   291
};

static const yytype_int16 yycheck[] =
{
      22,    23,   197,   374,   341,   449,   485,   486,   487,    62,
     888,   483,   484,   458,   758,   892,   888,   205,   553,   218,
      16,   892,   345,    19,   217,   181,   351,   383,    59,   812,
    1077,   760,   492,   611,    58,  1110,  1083,   615,  1079,     8,
      59,   886,   887,   867,    16,     1,    42,    59,    20,    87,
      88,    89,     1,    59,     3,    64,    40,   355,    60,   215,
     189,   190,    64,    87,    88,    89,    57,   891,   243,   244,
     245,   246,  1147,    64,    93,    87,   536,  1124,    87,    54,
      55,    87,    88,    89,    67,    68,   753,   754,    46,    72,
     967,    59,   970,    62,    52,  1136,    65,    73,    91,    49,
     767,   768,    78,    71,    79,    80,    42,    43,    76,    77,
      59,    57,    66,   411,   412,    54,    48,    49,    64,    73,
      59,   865,    71,    59,    54,    55,  1173,    76,    77,     0,
    1177,    87,    88,    89,   172,  1182,    59,    13,    87,   868,
      91,   172,   479,   480,   481,   482,   890,   172,    71,    79,
      80,   339,  1029,    76,    77,    64,   355,  1034,  1029,    49,
     182,    70,   606,  1034,    87,    88,    89,   538,    54,    49,
     493,    63,  1044,    59,    59,   620,   621,   161,    63,   757,
     202,   759,   965,   167,    54,   510,   969,   375,    62,    59,
      64,   213,   380,   386,   216,   172,    60,   181,   535,   355,
      64,    90,  1079,    87,   172,   173,   174,   175,   875,    87,
      59,   878,   196,   197,   881,    87,  1094,    89,   393,   394,
     395,   396,    87,   172,   173,   174,   175,   211,    59,    87,
     214,   215,    60,   217,   218,    59,    64,   221,    60,  1084,
      71,    77,    64,    53,    60,    76,    77,   231,    64,   172,
     173,   174,   175,    60,    96,   411,   412,    64,    87,  1136,
      95,    90,    63,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   189,   190,
     815,   816,  1159,    97,   819,   820,   189,   190,  1159,   867,
      59,  1169,  1137,  1138,   592,    59,  1174,  1169,   189,   190,
    1178,    46,  1174,    48,    49,    97,  1178,    52,    87,    88,
      89,   755,   890,   891,    90,   982,  1161,   172,   340,    81,
      82,   658,   766,   172,   173,   174,   175,   862,   101,   774,
     775,   101,   520,    87,   356,   357,   389,    59,    97,   170,
     171,   172,   173,   174,   175,   189,   190,    70,    71,    71,
      87,    88,    89,    97,    76,    77,   378,   189,   190,   381,
      83,    84,    85,   562,   563,    48,    49,   351,    90,    64,
      65,   355,    48,    49,    50,   359,   360,   576,    70,    71,
     364,   365,   557,   558,   559,   560,   179,   180,   923,   924,
     925,   926,    97,   377,   378,    70,    71,   592,   382,   383,
     384,   351,   386,   425,    35,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     389,    21,    22,    23,    24,    25,   422,   411,   412,    36,
      37,    38,    39,    87,    88,    89,   592,    59,    87,   435,
     884,    46,    17,    48,    49,    50,    51,    52,    69,    71,
     172,   173,   174,   175,    76,    77,   182,   183,   184,   185,
     186,   351,   183,   184,   185,   449,    73,    54,    90,    70,
      71,    59,   494,   172,  1009,  1010,   278,   279,   691,   692,
      87,    88,    89,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    59,    98,   518,   519,   477,   478,
     172,   187,   524,   525,   860,   861,    63,    97,    97,     4,
      63,   533,   711,    97,   713,    97,     4,     4,    28,    63,
      94,   189,   189,    47,   508,   190,    18,    18,    18,   551,
     705,   706,    18,    60,    64,    20,    74,   981,    63,   983,
      63,    59,   526,   742,   528,   529,    60,   992,    87,    75,
     172,   173,   174,   175,    54,   743,   578,   579,   169,   172,
     510,    59,   899,   547,   188,    64,  1045,   589,    64,   906,
      54,   173,   909,   172,  1046,   173,    59,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   781,    63,   172,   952,    63,   582,    26,
     584,   172,   172,   553,  1048,    87,  1050,    18,   592,  1081,
    1082,   177,    61,   597,    16,    60,    97,    97,   172,    56,
     510,   172,   606,    64,    60,    59,   825,    60,    59,   172,
     510,    59,    62,    27,    63,   172,   172,   172,   172,   172,
     172,   172,    19,    87,    60,   629,    60,    57,   670,   671,
     172,    60,    65,    60,   676,   677,   678,   177,    64,    55,
     682,    60,    97,   553,    64,   172,   172,   172,  1024,   172,
     172,   172,   201,   553,   182,    59,    59,    59,   700,    15,
      56,    56,    87,    69,    55,    64,    60,   709,   710,    57,
     712,    60,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,    54,   168,   169,   170,   171,
      60,   172,   734,   181,    56,    56,    56,  1073,    56,    14,
      64,    60,    57,    60,   746,   747,    54,   711,    55,   713,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,    55,    64,    72,    57,   172,   733,
      64,    59,   736,   737,    60,   178,    57,   741,   742,   276,
      64,    60,    60,    57,    64,    55,   750,    64,   752,   753,
     754,   755,    64,   795,   178,   100,    64,    60,   800,    57,
      64,   803,   766,   767,   768,    57,    99,    64,  1125,   178,
      60,    64,   814,    57,    57,    64,    64,    57,    57,   821,
      57,   240,   824,   554,   826,   827,   828,   829,   830,   901,
     623,   833,   237,   835,   836,   837,   838,   421,   868,   969,
     299,   869,   844,   884,   158,   766,   757,   592,   386,   742,
     378,   464,   351,   785,   362,   297,   169,   169,   300,   474,
     476,   825,    -1,   473,   338,   192,   475,    -1,   310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   815,   816,    -1,    -1,   819,
     820,    -1,    -1,    -1,    -1,    -1,   860,   861,    -1,   341,
      -1,    -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   875,    -1,   915,   878,    -1,    -1,   881,   920,    -1,
     884,   885,   886,   887,   888,   927,    -1,    -1,   930,   931,
      -1,    -1,   862,    -1,    -1,   937,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   815,   816,    -1,   950,   819,
     820,    -1,    -1,    -1,    -1,   815,   816,    -1,    -1,   819,
     820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   952,    -1,
      -1,    -1,   862,   923,   924,   925,   926,    -1,    -1,    -1,
    1002,    -1,   862,    -1,  1006,    -1,   970,    -1,    -1,   451,
     452,   453,   454,  1015,    -1,   457,    -1,   981,   982,   983,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   470,   471,
     168,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,   923,   924,   925,   926,  1059,    -1,    -1,
    1024,    -1,   504,   923,   924,   925,   926,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    -1,   517,    -1,    -1,    -1,  1009,
    1010,    -1,    -1,    -1,  1048,    -1,  1050,    -1,  1052,    -1,
      -1,    -1,    -1,   535,    -1,    -1,    -1,    -1,  1100,    -1,
      -1,    -1,    -1,   545,    -1,    -1,    -1,    -1,    -1,  1073,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1094,    36,    37,    38,    39,    -1,    -1,    -1,    -1,  1009,
    1010,  1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1009,
    1010,    -1,    -1,    58,    59,    -1,    -1,    -1,    -1,   297,
      -1,  1163,   300,    -1,    -1,   305,    71,    -1,    73,    -1,
      -1,    76,    77,  1137,  1138,    -1,    -1,   619,    -1,    -1,
      -1,    -1,    87,    88,    89,    -1,    -1,    -1,   630,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1161,    -1,    -1,
      -1,    -1,    -1,   341,    -1,  1169,   344,    -1,    -1,    -1,
    1174,    -1,    -1,    -1,  1178,   657,   658,   659,   358,    -1,
      36,    37,    38,    39,    -1,   667,   668,   367,   368,    -1,
     370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   694,   695,    -1,    71,    -1,    -1,    -1,    -1,
      76,    77,    -1,    -1,    -1,   170,   171,   172,   173,   174,
     175,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    38,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,   449,
      -1,    -1,    -1,   451,   452,   453,   454,    -1,    71,   457,
      73,    -1,    -1,    76,    77,    -1,   466,    -1,    -1,    -1,
      -1,    -1,   470,   471,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,   785,    -1,    -1,    -1,    -1,    -1,    36,
      37,    38,    39,    -1,   170,   171,   172,   173,   174,   175,
      -1,    -1,    -1,    -1,    -1,    -1,   504,    -1,    -1,    -1,
      -1,    58,    59,    -1,    36,    37,    38,    39,    -1,   517,
      -1,   521,   522,    -1,    71,    -1,    -1,    -1,   528,    76,
      77,   531,   532,    -1,   534,    -1,    -1,    59,    -1,    -1,
      87,    88,    89,    -1,    -1,    -1,    -1,   545,   548,    71,
     550,    -1,    -1,    -1,    76,    77,    -1,   170,   171,   172,
     173,   174,   175,    -1,    -1,    87,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,
      38,    39,    -1,   885,   886,   887,   888,    -1,    -1,    -1,
      -1,   893,    -1,    -1,    -1,    -1,    -1,   899,    -1,    -1,
      -1,    59,    -1,    -1,   906,    -1,   606,   909,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    77,
      -1,   619,    -1,   170,   171,   172,   173,   174,   175,    87,
      88,    89,   630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   170,   171,
     172,   173,   174,   175,    -1,    -1,    -1,    -1,    -1,   657,
      -1,   659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   667,
     668,    -1,    -1,    -1,   674,    -1,    -1,    -1,    -1,    -1,
     680,   681,    -1,    -1,   684,    -1,    -1,   687,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   694,   695,   698,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   170,   171,   172,   173,   174,   175,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,   728,   729,
      -1,   731,   732,    -1,    -1,  1037,  1038,    -1,    -1,  1041,
      -1,  1043,  1044,  1045,  1046,    -1,    -1,    -1,    -1,   749,
      -1,    -1,   752,   753,   754,   755,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   766,   767,   768,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,  1081,
    1082,    -1,  1084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   796,   797,   798,   799,
      -1,    -1,   802,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1118,    -1,  1120,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1137,  1138,    -1,    -1,    -1,
     840,   841,   842,   843,    -1,   845,   846,   847,    -1,    -1,
    1152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1161,
      -1,    -1,   862,   863,   864,    -1,    -1,  1169,    -1,    -1,
     305,    -1,  1174,    -1,    -1,   875,  1178,    -1,   878,    -1,
      -1,   881,    -1,    -1,   884,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   892,    -1,    -1,   893,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     910,    -1,   912,   913,   914,    -1,   916,    -1,    -1,    -1,
      -1,   921,   922,   358,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,
     940,    -1,    -1,   943,   944,   945,   946,   947,   948,    -1,
      -1,   951,    -1,    -1,    -1,   955,   956,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   967,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   981,   982,   983,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1001,    -1,  1003,    -1,    -1,    -1,  1007,  1008,    -1,
      -1,  1011,  1012,    -1,    -1,    -1,    -1,  1017,  1018,  1019,
    1020,    -1,  1022,  1023,    -1,  1025,  1026,  1027,    -1,  1029,
      -1,   466,    -1,    -1,  1034,    -1,    -1,    -1,    -1,  1037,
    1038,    -1,    -1,  1041,    -1,  1043,    -1,    -1,  1048,    -1,
    1050,    -1,    -1,    -1,    -1,    -1,    -1,  1057,    -1,    -1,
      -1,    -1,  1062,  1063,  1064,  1065,    -1,    -1,    -1,  1069,
      -1,  1071,  1072,    -1,    -1,  1075,    -1,    -1,    -1,  1079,
      -1,    -1,    -1,    -1,    -1,    -1,   521,   522,    -1,    -1,
      -1,    -1,    -1,   528,    -1,    -1,   531,   532,    -1,   534,
      -1,  1101,  1102,  1103,  1104,    -1,    -1,  1107,  1108,  1109,
      -1,    -1,    -1,   548,    -1,   550,    -1,    -1,    -1,    -1,
      -1,    -1,  1120,    -1,    -1,    -1,    -1,  1127,  1128,    -1,
      -1,  1131,  1132,    -1,  1134,    -1,  1136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1146,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1158,  1159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   674,
      59,    -1,    61,    62,    -1,   680,   681,    -1,    -1,   684,
      -1,    -1,   687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   698,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   728,   729,    -1,   731,   732,    -1,   118,
     119,    -1,    -1,    -1,    -1,   124,   125,   126,    -1,    -1,
      -1,   130,   131,   132,   749,    -1,   135,   136,   137,   138,
     139,    -1,    -1,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,    -1,
      -1,   160,   161,    -1,    -1,   164,   165,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   796,   797,   798,   799,    -1,    -1,   802,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     199,   200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   840,   841,   842,   843,    -1,
     845,   846,   847,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   862,   863,   864,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   910,    -1,   912,   913,   914,
      -1,   916,    -1,    -1,    -1,    -1,   921,   922,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   940,    -1,    -1,   943,   944,
     945,   946,   947,   948,    -1,    -1,   951,    -1,    -1,    -1,
     955,   956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1001,    -1,  1003,    -1,
      -1,    -1,  1007,  1008,    -1,    -1,  1011,  1012,    -1,    -1,
      -1,    -1,  1017,  1018,  1019,  1020,    -1,  1022,  1023,    -1,
    1025,  1026,  1027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1057,    -1,    -1,    -1,    -1,  1062,  1063,  1064,
    1065,    -1,    -1,    -1,  1069,    -1,  1071,  1072,    -1,    -1,
    1075,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1101,  1102,  1103,  1104,
      -1,    -1,  1107,  1108,  1109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1127,  1128,    -1,    -1,  1131,  1132,    -1,  1134,
     199,   200,   201,    -1,    -1,   204,    -1,    -1,   207,    -1,
      -1,  1146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1158,    -1,    -1,    -1,    -1,   227,   228,
      -1,    -1,    -1,  1168,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   241,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   272,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,   281,   282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    -1,    61,    62,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,   414,   415,    -1,   417,    -1,
     419,    86,    -1,    -1,    -1,   424,    91,    92,   427,    -1,
      -1,    -1,    -1,    -1,   433,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    -1,   581,    -1,   583,    -1,    -1,   586,   587,    -1,
      59,    -1,    61,    62,    -1,    -1,   595,   596,    -1,    -1,
      -1,   600,    -1,   602,   603,   604,   605,    -1,   607,   608,
     609,   610,    -1,   612,   613,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,
     119,    -1,    -1,    -1,    -1,   124,   125,   126,    -1,    -1,
      -1,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,    -1,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,    -1,
      -1,   160,   161,    -1,    -1,   164,   165,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   707,   708,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
     199,   200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,    -1,    -1,    -1,   817,   818,
      -1,    -1,    29,    30,    31,    32,    33,    34,    -1,    -1,
     118,   119,    -1,    40,    -1,    -1,   124,   125,   126,    -1,
     839,    -1,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,    -1,    -1,    -1,   144,   145,   146,   147,
     859,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
      -1,    -1,   160,   161,    -1,    -1,   164,   165,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   199,   200,   120,   121,   122,   123,    -1,    -1,    -1,
     127,   128,   129,    -1,    -1,    -1,   133,   134,    -1,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,    -1,
      -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,   158,   159,    -1,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,   193,   194,   195,   196,
     197,   198
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   203,   206,   207,     0,    91,    13,   204,   215,
     172,   207,    63,     5,     6,     7,     8,     9,    10,    11,
      12,    41,    44,    45,    59,    61,    86,    92,   102,   118,
     119,   124,   125,   126,   130,   131,   132,   135,   136,   137,
     138,   139,   144,   145,   146,   147,   149,   150,   151,   152,
     153,   154,   155,   156,   160,   161,   164,   165,   166,   167,
     199,   200,   205,   208,   209,   210,   213,   214,   216,   217,
     218,   219,   220,   221,   223,   224,   225,   228,   229,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   261,   262,   263,   264,   265,   266,   267,
     269,   270,   272,   275,   276,   278,   279,   281,   283,   284,
     285,   286,   287,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   321,   322,   323,   326,
     328,   329,   330,   331,   332,   333,   334,   335,   337,   403,
     172,    87,    87,    90,   212,    90,   212,    87,    87,   212,
      87,    59,   384,    36,    37,    38,    39,    58,    59,    71,
      76,    77,    87,    88,    89,   170,   171,   172,   173,   174,
     175,   341,   348,   353,   369,   370,   371,   372,   373,   377,
     386,   387,   399,   400,   348,    77,   338,   384,    53,   342,
      42,    43,   384,    96,   336,    95,    63,   383,    97,    97,
      59,   355,   386,    59,   356,   212,   384,   384,   384,    90,
     172,   341,   349,   353,   370,   101,   101,    97,    97,    87,
      87,    97,   189,   190,   302,    35,   340,   206,   207,     1,
     207,    29,    30,    31,    32,    33,    34,    40,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   120,   121,   122,   123,   127,   128,   129,
     133,   134,   140,   141,   142,   143,   148,   157,   158,   159,
     162,   163,   168,   176,   191,   192,   193,   194,   195,   196,
     197,   198,    21,    22,    23,    24,    25,    17,   226,   226,
      69,   172,   385,   386,    88,   359,   360,   387,   380,   386,
      71,   172,   173,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   173,   371,   372,   399,   399,
     399,    48,    49,    48,    49,    50,    59,    87,   377,   386,
     348,    54,   375,   376,    59,   378,    46,    52,   402,   379,
     386,   343,   363,   381,   386,   384,   384,   384,   348,   384,
     378,   172,   384,    59,   382,    98,   172,   386,   359,   348,
     386,   345,   364,   365,   377,   386,   348,   344,   358,   364,
     386,   379,   384,   384,   386,   187,   384,   208,    62,   205,
     211,   384,   384,   383,   383,   383,   383,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   384,   384,    63,    97,    97,     4,    97,    63,    97,
       4,     4,   384,   384,    93,   384,   384,   340,    28,   277,
     277,   277,    94,   282,   384,   384,    63,   189,   190,   189,
     189,   190,   189,   190,   189,   189,   190,   189,   190,   190,
      47,    18,    18,    18,    18,   388,    16,    20,   227,   235,
     227,    90,   388,    60,    64,    63,   359,    63,   361,    57,
      64,    59,    60,    73,    78,    74,    75,    81,    82,    54,
      55,    79,    80,    70,    71,    83,    84,    85,    67,    68,
      72,    87,   376,   378,   348,   388,   395,    48,    49,    50,
      51,   401,   402,   388,    54,   375,   169,   339,    73,   351,
     352,   353,   366,   367,   368,   381,   386,    59,   345,   379,
     386,   348,   348,   359,   386,   386,   336,   172,   386,   386,
      64,   359,   359,    64,   359,    54,   374,   374,   378,    59,
     357,   386,   348,   357,   386,    59,   348,    59,   271,   386,
     271,   386,   188,   344,   207,   173,   173,   383,   383,   383,
     383,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   345,   345,   172,   384,   384,
      63,   288,   384,   172,   384,    63,   268,   268,   212,   384,
     348,    87,   384,    26,   273,    97,    97,   384,   172,   212,
     172,   177,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,    88,   319,   359,   386,   387,    18,
     388,   388,   388,   388,    61,   388,   235,   385,   172,   359,
      59,   172,   388,   388,   391,   390,   392,   393,   394,   394,
     395,   395,   395,   395,   398,   398,   397,   397,   397,   399,
     399,   399,    60,   401,   375,   348,    64,    65,    55,    64,
     388,    60,   386,   350,   353,   366,   370,    56,    59,   388,
     348,   348,   359,   359,   348,   172,   260,   348,   386,    60,
     359,   386,   386,   172,   359,   359,   348,   359,   395,   401,
     374,    64,    87,   327,    59,    59,   388,   386,   359,   359,
     348,   349,   211,   172,   172,   383,   383,   383,   383,   345,
     345,   379,   345,   379,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   379,    63,   348,   348,
     172,   384,   386,   384,   386,   172,   384,   384,   348,   172,
     172,   343,   345,   386,    27,   274,   384,   384,   386,   172,
     384,   177,   384,   384,   384,   384,   319,   325,   384,   384,
     384,   384,   183,   184,   185,   313,   324,   384,   384,   313,
     388,   235,   235,    19,   222,   222,    87,   233,   234,    60,
     354,   386,   388,    57,    60,    66,   172,   388,   388,   388,
     388,    60,   348,   348,   359,   348,   348,   348,   359,   359,
     348,    60,   359,    64,   359,    55,   327,   327,    60,   388,
     388,    60,    64,   359,   348,   172,   172,   383,   383,   384,
     384,   348,   348,   379,   348,   379,   348,   348,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   172,
     359,   359,   359,   359,   386,   348,   386,   386,   172,   172,
     172,   346,   347,   348,   366,   368,   346,   379,   386,    97,
     348,   348,   280,   359,   386,   317,   319,   317,   317,   318,
     319,   201,   324,   182,   186,   304,   312,   313,   309,   313,
     304,   305,   312,   182,   306,    59,    59,    59,    56,   325,
     317,   317,    56,    15,   230,   231,    87,   235,   235,    69,
      62,    64,   378,    60,   389,    55,    64,    60,    57,    54,
     348,   359,   359,   359,   359,   348,   359,   348,    60,   400,
     348,   349,   349,   384,   384,   349,   349,   348,   348,   379,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     384,   359,   359,   359,   359,   348,   359,   359,   359,   172,
     384,   271,   271,   349,   359,   359,   359,   304,   179,   180,
     309,   305,   306,   181,   317,    56,   317,    56,   317,    56,
      56,   318,   314,   315,   316,   386,   388,   314,   314,   315,
     316,   304,   313,   309,   320,   360,   387,     1,     3,    87,
     388,    14,   232,    90,   395,   233,   395,   395,   359,   359,
     359,   359,   348,   359,    60,    60,   348,   359,   359,   349,
     349,   349,   349,   348,   348,   348,   348,   359,   359,   359,
     359,   359,   359,   359,   348,   359,   271,   359,   359,   311,
     400,   307,   308,   320,   311,   316,    60,    64,    59,    63,
      60,    64,    60,    64,    64,    70,    71,   310,   319,   317,
     319,    57,    54,   235,    55,    55,   359,   348,   359,   348,
     359,   359,   349,   349,   359,   359,   348,   359,   359,   359,
     359,   359,   359,   271,   359,   359,   359,   320,    72,    64,
      57,    70,    71,   320,    64,    70,   388,   388,   172,   388,
     388,   315,   397,   398,    64,   319,   319,     1,   386,   359,
     348,   359,   359,   359,   359,   359,   359,   359,   271,   362,
     359,   310,   307,   178,   398,   398,   310,   314,    59,    60,
      64,    60,    60,    57,   316,    64,   348,   359,   359,   359,
     359,   359,   359,   359,   362,    57,    64,    64,    64,   399,
     388,   310,   395,   100,   359,   359,   359,   359,   178,   307,
     314,   314,    64,    60,    57,    55,   348,   359,   362,    64,
      57,    64,   399,    99,   320,   178,   314,    60,   348,    64,
      57,   359,   315,   316,    64,   310,   315,   316,    64,    57,
     310,   315,   316,    57,    57,   310,    57
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   202,   203,   204,   205,   205,   206,   206,   207,   207,
     208,   208,   208,   208,   208,   208,   208,   208,   208,   208,
     208,   209,   209,   209,   210,   211,   212,   212,   213,   214,
     215,   216,   216,   216,   216,   216,   216,   217,   218,   219,
     220,   221,   222,   222,   223,   224,   224,   225,   225,   226,
     226,   227,   228,   228,   228,   228,   229,   230,   230,   231,
     231,   231,   231,   232,   232,   232,   233,   233,   233,   234,
     234,   235,   235,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   237,   238,   238,   238,   238,
     239,   239,   240,   241,   242,   243,   243,   244,   244,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   255,   255,   256,   257,   257,   257,   258,   258,   259,
     259,   260,   261,   262,   263,   264,   265,   265,   265,   265,
     265,   265,   266,   267,   268,   268,   269,   270,   270,   271,
     271,   272,   273,   273,   274,   274,   275,   276,   277,   277,
     278,   279,   280,   280,   280,   281,   282,   282,   283,   284,
     285,   285,   285,   286,   287,   287,   287,   287,   287,   287,
     287,   288,   288,   289,   289,   289,   289,   289,   289,   289,
     289,   289,   289,   289,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   302,   303,
     303,   304,   305,   305,   306,   306,   306,   306,   306,   307,
     307,   307,   308,   308,   308,   308,   309,   310,   310,   310,
     311,   311,   312,   312,   312,   312,   313,   313,   313,   313,
     313,   313,   314,   314,   315,   316,   316,   316,   317,   317,
     318,   319,   319,   320,   320,   321,   321,   321,   322,   323,
     324,   324,   325,   326,   327,   327,   327,   328,   328,   328,
     328,   328,   328,   328,   328,   329,   330,   331,   331,   332,
     333,   334,   334,   334,   334,   335,   335,   335,   335,   335,
     335,   335,   335,   336,   336,   337,   337,   338,   338,   339,
     339,   340,   340,   341,   341,   341,   341,   342,   342,   343,
     344,   345,   345,   346,   346,   347,   347,   348,   348,   348,
     349,   349,   350,   350,   350,   351,   351,   352,   352,   353,
     354,   355,   356,   357,   358,   359,   359,   360,   361,   361,
     362,   362,   363,   364,   364,   365,   366,   366,   367,   368,
     369,   369,   370,   370,   370,   370,   370,   370,   371,   371,
     371,   372,   372,   372,   373,   373,   374,   375,   376,   376,
     376,   377,   377,   378,   379,   380,   381,   382,   382,   383,
     384,   384,   385,   386,   386,   387,   387,   388,   389,   389,
     390,   390,   391,   391,   392,   392,   393,   393,   393,   394,
     394,   394,   394,   394,   395,   396,   396,   396,   396,   397,
     397,   397,   398,   398,   398,   398,   399,   399,   399,   399,
     400,   400,   400,   400,   400,   400,   401,   401,   401,   401,
     401,   402,   402,   403
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     2,     3,     2,     0,     1,     2,
       2,     2,     2,     0,     6,     3,     3,     3,     1,     3,
       1,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     8,     9,
       6,     6,     6,     7,     6,     7,     6,     8,     7,     7,
       6,     8,     8,     5,     6,     5,     4,     7,     7,     7,
       6,     6,     6,     1,     4,     4,     4,     6,     6,     8,
       7,     1,     8,    10,     8,     9,     1,     1,     1,     5,
       3,     2,    10,    13,     0,     2,    10,     9,     8,     1,
       5,    13,     0,     1,     0,     1,    10,    11,     0,     1,
       6,     5,     0,     2,     2,     6,     0,     1,     9,    16,
       9,     5,     6,     6,     5,     5,     4,     9,     9,     7,
       7,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     7,     7,     7,
       7,     9,     7,     7,     9,     8,     4,     1,     1,     0,
       2,     7,     9,     1,    16,    14,    15,    15,    10,     1,
       3,     3,     1,     3,     5,     7,     5,     0,     2,     2,
       0,     2,     0,     1,     1,     1,     4,     6,     4,     6,
       4,     6,     1,     1,     1,     1,     3,     6,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     6,     6,
       6,     8,     2,     8,     0,     2,     2,     4,     4,     3,
       6,     6,     6,     7,     3,     2,     2,     9,     9,     2,
       2,    12,    12,    11,    11,     1,     2,     1,     1,     2,
       1,     2,     1,     0,     1,     0,     5,     0,     1,     0,
       1,     0,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     5,     7,     4,     4,     1,     3,     2,     2,     4,
       0,     2,     1,     3,     2,     3,     1,     4,     2,     1,
       3,     4,     2,     2,     1,     2,     1,     2,     1,     2,
       2,     1,     2,     2,     3,     4,     3,     7,     1,     5,
       3,     5,     3,     5,     1,     4,     7,     0,     3,     2,
       3,     5,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     1,     3,     3,     3,     1,     3,
       3,     1,     3,     3,     3,     1,     2,     2,     2,     1,
       1,     1,     3,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 671 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3117 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 701 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3125 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 705 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3134 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 709 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3140 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 720 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3149 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 728 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3158 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 736 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3166 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 750 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3174 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 757 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3184 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 765 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3194 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 773 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3203 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 780 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3211 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 783 "CISA.y"
                    {(yyval.string) = "";}
#line 3217 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 783 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3223 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 787 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3232 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 795 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3240 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 800 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3251 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 812 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3260 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 819 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3271 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 826 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3277 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 826 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3283 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 827 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3289 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 833 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3297 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 837 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3305 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 841 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3313 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 845 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3321 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 851 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3329 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* AlignAttrOpt: %empty  */
#line 856 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3335 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 59: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 858 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3343 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ IDENT  */
#line 862 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3353 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IntExp  */
#line 868 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3365 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ error  */
#line 876 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3373 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* AliasAttrOpt: %empty  */
#line 883 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3382 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 888 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3391 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 893 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3399 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 899 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3407 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 903 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3415 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT  */
#line 907 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3423 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 913 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3431 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: OneAttr  */
#line 918 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3439 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* GenAttrOpt: %empty  */
#line 924 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3447 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 928 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3455 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* Label: LABEL  */
#line 990 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3461 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 995 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3470 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 1001 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3478 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1006 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3487 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1012 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3496 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1019 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3505 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 1025 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3514 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1032 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3523 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1039 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3532 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1046 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3541 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1053 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3553 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_3OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM  */
#line 1063 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, nullptr, CISAlineno);
    }
#line 3562 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1072 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3571 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1079 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3580 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* ArithInstruction_4OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1086 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3589 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1095 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3600 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1105 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3609 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1111 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3618 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1118 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3626 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1124 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3635 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1133 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3647 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1143 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3656 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1150 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3665 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1157 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3674 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1165 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3684 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1174 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3694 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1181 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3704 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1188 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3712 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* BreakpointInstruction: BREAKPOINT_OP  */
#line 1194 "CISA.y"
    {
      pBuilder->CISA_create_breakpoint_instruction(CISAlineno);
    }
#line 3720 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1200 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3729 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1206 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3738 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1212 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3747 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1230 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3756 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1237 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3767 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1247 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3777 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1255 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3787 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1261 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3796 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1269 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3806 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1278 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3816 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1287 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3826 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1296 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3836 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: BARRIER_OP  */
#line 1303 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3844 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1306 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3852 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1309 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3860 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1312 "CISA.y"
                                                                                                              {
        pBuilder->CISA_create_nbarrier_signal((yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3868 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1315 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3876 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1318 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3884 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1324 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3893 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1331 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3903 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* Atomic16Opt: %empty  */
#line 1338 "CISA.y"
             {(yyval.flag) = false;}
#line 3909 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Atomic16Opt: DOT DEC_LIT  */
#line 1339 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3918 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1346 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3928 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1359 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3938 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1367 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3948 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* SamplerAddrOperand: Var  */
#line 1374 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[0].string), (unsigned int)0};
                     }
#line 3956 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* SamplerAddrOperand: LPAREN Var COMMA IntExpPrim RPAREN  */
#line 1379 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[-3].string), (unsigned int)(yyvsp[-1].intval)};
                     }
#line 3964 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1390 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-12].pred_reg), (yyvsp[-11].sample3DOp), (yyvsp[-10].pixel_null_mask), (yyvsp[-9].cps), (yyvsp[-8].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-7].s_channel)),
           (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset,
           (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3978 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* CPSEnableOpt: %empty  */
#line 1400 "CISA.y"
                     {(yyval.cps) = false;}
#line 3984 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* CPSEnableOpt: CPS  */
#line 1400 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3990 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* NonUniformSamplerEnableOpt: %empty  */
#line 1402 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3996 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1402 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 4002 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1412 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4015 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1429 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-10].pred_reg), (yyvsp[-9].sample3DOp), (yyvsp[-8].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size,
          (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar),
          (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4029 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* PixelNullMaskEnableOpt: %empty  */
#line 1440 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 4035 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1440 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 4041 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand RawOperand  */
#line 1444 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].sampler_base).base, (yyvsp[-2].sampler_base).offset, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4051 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand  */
#line 1452 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].sampler_base).base, (yyvsp[-1].sampler_base).offset, NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 4061 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWriteOperands: %empty  */
#line 1460 "CISA.y"
    {
    }
#line 4068 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1463 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 4076 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1467 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 4084 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1475 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 4097 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* RTWriteModeOpt: %empty  */
#line 1485 "CISA.y"
                       {(yyval.string) = 0;}
#line 4103 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1490 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4113 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1498 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4125 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1510 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4143 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1526 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4151 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1532 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4166 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1545 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4175 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1553 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4184 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1560 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4193 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1568 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4202 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1574 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4211 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1580 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4220 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1586 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4229 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 210: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1592 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4238 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 211: /* AtomicBitwidthOpt: %empty  */
#line 1598 "CISA.y"
             {(yyval.intval) = 32;}
#line 4244 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 212: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1599 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4253 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1654 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4278 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1686 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4303 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1716 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4326 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1744 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4351 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1770 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4376 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1798 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4399 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1827 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,         // address info
            (yyvsp[-3].lsc_data_operand).shape,        // data type
            (yyvsp[-2].lsc_addr_operand).surface,      // surface array base
            (yyvsp[-2].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,          // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],      // src0 addr
            (yyvsp[-1].RawVar),              // src1 data
            (yyvsp[0].RawVar),              // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4424 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1861 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,      // address type
            (yyvsp[0].lsc_typed_operand).addr.size,      // address size
            (yyvsp[-1].lsc_data_operand).shape,          // data
            (yyvsp[0].lsc_typed_operand).surface,        // surface
            (yyvsp[0].lsc_typed_operand).surfaceIndex,   // surface index
            (yyvsp[-1].lsc_data_operand).reg,            // dst
            (yyvsp[0].lsc_typed_operand).regs[0],        // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0],  // u offset
            (yyvsp[0].lsc_typed_operand).regs[1],        // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1],  // v offset
            (yyvsp[0].lsc_typed_operand).regs[2],        // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2],  // r offset
            (yyvsp[0].lsc_typed_operand).regs[3],        // src0_lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
    }
#line 4459 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1905 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data size
            (yyvsp[-1].lsc_typed_operand).surface,       // surface
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0_lod
            (yyvsp[0].lsc_data_operand).reg,           // stored data
            nullptr,          // src2
            CISAlineno);
    }
#line 4494 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets LscPayloadReg LscPayloadReg  */
#line 1950 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_typed_operand).addr.type, // address model
            (yyvsp[-2].lsc_typed_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_typed_operand).surface,  // surface
            (yyvsp[-2].lsc_typed_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_typed_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-2].lsc_typed_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-2].lsc_typed_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-2].lsc_typed_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4526 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscAddrModelStateful LBRACK LscPayloadNonNullReg RBRACK  */
#line 1986 "CISA.y"
   {
        LSC_CACHE_OPTS caching {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape {LSC_DATA_SIZE_32b,LSC_DATA_ORDER_TRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_16;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-7].pred_reg),              // predicate
            (yyvsp[-6].lsc_subOpcode),              // subop
            (yyvsp[-5].lsc_sfid),              // sfid
            caching,         // no caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[-3].lsc_addr_model).type,           // address type
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[-3].lsc_addr_model).surface,        // surface
            (yyvsp[-3].lsc_addr_model).surfaceIndex,   // SS_IDX
            (yyvsp[-4].RawVar),                // dst data
            (yyvsp[-1].RawVar),                // src0 coords (u, v, r, lod) SIMD1 are packed in
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            nullptr,           // no src1 data
            nullptr,           // no src2 data
            CISAlineno);
   }
#line 4559 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 2023 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4567 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscCacheOpts: %empty  */
#line 2030 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts(CISAlineno);}
#line 4573 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 2031 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts((yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt), CISAlineno);}
#line 4579 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 2038 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface, (yyvsp[-6].lsc_addr_model).surfaceIndex, {(yyvsp[-3].RawVar)}, {(yyvsp[-6].lsc_addr_model).type, (int)(yyvsp[-4].intval), (int)(yyvsp[-2].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4587 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm32 RBRACK LSC_ADDR_SIZE_TK  */
#line 2047 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface, (yyvsp[-8].lsc_addr_model).surfaceIndex, {(yyvsp[-5].RawVar), (yyvsp[-2].lsc_addr_surface_ident)}, {(yyvsp[-8].lsc_addr_model).type, (int)(yyvsp[-6].intval), (int)(yyvsp[-4].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4595 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 2050 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4604 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2074 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-13].lsc_addr_surface_ident),(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4612 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2094 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0, 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4620 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2114 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-12].lsc_addr_surface_ident),(yyvsp[-10].lsc_addr_surface_ident),(yyvsp[-8].lsc_addr_surface_ident),(yyvsp[-6].lsc_addr_surface_ident),(yyvsp[-4].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{0, (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4628 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpImm32 RBRACK  */
#line 2134 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-12].lsc_addr_surface_ident),(yyvsp[-10].lsc_addr_surface_ident),(yyvsp[-8].lsc_addr_surface_ident),(yyvsp[-6].lsc_addr_surface_ident),(yyvsp[-4].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{(int)(yyvsp[-3].intval), 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4636 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg PLUS LPAREN IntExpUnr COMMA IntExpUnr RPAREN RBRACK  */
#line 2142 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-7].lsc_addr_surface_ident),nullptr,nullptr,nullptr,nullptr,nullptr},{(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4644 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg  */
#line 2147 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[0].RawVar), 0};
    }
#line 4652 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg PLUS IntExpMul  */
#line 2150 "CISA.y"
                                          {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)(yyvsp[0].intval)};
    }
#line 4660 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg MINUS IntExpMul  */
#line 2154 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)-(yyvsp[0].intval)};
    }
#line 4668 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand  */
#line 2158 "CISA.y"
                                    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[0].lsc_typed_addr_operand).offset, 0, 0}};
      }
#line 4676 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2163 "CISA.y"
      {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset, 0}};
      }
#line 4684 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2169 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset}};
    }
#line 4692 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscPayloadNonNullReg  */
#line 2176 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-6].lsc_typed_addr_operand).reg,(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].RawVar)}, {(yyvsp[-6].lsc_typed_addr_operand).offset, (yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset}};
    }
#line 4700 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscTypedAddrOperandWithOffsets: LscAddrModelStateful LBRACK LscTypedAddrWithOffsetOperandList RBRACK LSC_ADDR_SIZE_TK  */
#line 2182 "CISA.y"
    {
        (yyval.lsc_typed_operand) = {(yyvsp[-4].lsc_addr_model).surface, (yyvsp[-4].lsc_addr_model).surfaceIndex,
               {(yyvsp[-2].lsc_typed_addr_operand_list).regs[0], (yyvsp[-2].lsc_typed_addr_operand_list).regs[1], (yyvsp[-2].lsc_typed_addr_operand_list).regs[2],(yyvsp[-2].lsc_typed_addr_operand_list).regs[3]},
               {(yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[0], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[1], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[2]},
               {(yyvsp[-4].lsc_addr_model).type, 1, 0, (yyvsp[0].lsc_addr_size)}};
    }
#line 4711 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscAddrImmOffsetOpt: %empty  */
#line 2193 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4717 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2194 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4723 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscAddrImmOffsetOpt: MINUS IntExpMul  */
#line 2195 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4729 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscAddrImmScaleOpt: %empty  */
#line 2200 "CISA.y"
                     {(yyval.intval) = 1;}
#line 4735 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrImmScaleOpt: IntExpPrim TIMES  */
#line 2201 "CISA.y"
                     {(yyval.intval) = (yyvsp[-1].intval);}
#line 4741 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscAddrModelOpt: %empty  */
#line 2204 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4747 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2205 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4753 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2206 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG, nullptr, 0};}
#line 4759 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2211 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4767 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2214 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS, (yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4775 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2217 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4783 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2220 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4791 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2223 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4799 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2226 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4807 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscVectorOpImm32: IntExp  */
#line 2235 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval), ISA_TYPE_UD, CISAlineno);
    }
#line 4815 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscVectorOpReg: Var  */
#line 2245 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4827 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2253 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4839 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2261 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4856 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2275 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4864 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2279 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4872 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2285 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4880 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* LscPayloadReg: Var  */
#line 2293 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4888 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* LscPayloadNonNullReg: VarNonNull  */
#line 2300 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4896 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* LscTypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscDataOperandTyped2D LscTypedBlock2dAddrOperand  */
#line 2324 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[0].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[-1].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[0].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[0].lsc_block2d_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand_typed2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[0].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            nullptr,     // src1
            CISAlineno);
   }
#line 4917 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* LscTypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscTypedBlock2dAddrOperand LscDataOperandTyped2D  */
#line 2353 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[-1].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[0].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[-1].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[-1].lsc_block2d_addr_operand).surfaceIndex,
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[-1].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            (yyvsp[0].lsc_data_operand_typed2d).reg,      // src1
            CISAlineno);
    }
#line 4938 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2379 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-5].lsc_addr_model).surface, 0, {(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0,0},{(yyvsp[-5].lsc_addr_model).type,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4946 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2389 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-7].lsc_addr_model).surface, (yyvsp[-7].lsc_addr_model).surfaceIndex, {(yyvsp[-5].lsc_addr_surface_ident), (yyvsp[-2].lsc_addr_surface_ident)}, {(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)}, {(yyvsp[-7].lsc_addr_model).type, 1, 0, LSC_ADDR_SIZE_64b}};
    }
#line 4954 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* LscDataOperandTyped2D: LscPayloadReg LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
#line 2395 "CISA.y"
                                                  {
        (yyval.lsc_data_operand_typed2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape_typed2d)};
    }
#line 4962 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* LscUntypedApndCtrAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscAddrModelStateful LscDataOperand  */
#line 2407 "CISA.y"
    {
        (yyvsp[-3].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-5].lsc_sfid), (yyvsp[-6].lsc_subOpcode), (yyvsp[-2].lsc_data_operand).shape.order, (yyvsp[-3].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_append_counter_atomic_inst(
            (yyvsp[-6].lsc_subOpcode),          // op
            (yyvsp[-7].pred_reg),          // predicate
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-3].emask_exec_size).exec_size),
            (yyvsp[-3].emask_exec_size).emask,    // execution mask
            (yyvsp[-4].lsc_caching_opts),          // caching settings
            (yyvsp[-1].lsc_addr_model).type,     // address type
            (yyvsp[-2].lsc_data_operand).shape,    // data shape
            (yyvsp[-1].lsc_addr_model).surface,  // surface
            (yyvsp[-1].lsc_addr_model).surfaceIndex,
            (yyvsp[-2].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            CISAlineno);
    }
#line 4984 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* SwitchLabels: %empty  */
#line 2427 "CISA.y"
    {
    }
#line 4991 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* SwitchLabels: COMMA SwitchLabels  */
#line 2430 "CISA.y"
    {
    }
#line 4998 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* SwitchLabels: IDENT SwitchLabels  */
#line 2433 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 5007 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2440 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 5015 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2444 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 5023 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2448 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 5031 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2452 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 5040 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2458 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5048 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2463 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, false,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5058 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* BranchInstruction: Predicate IFCALL UNIFORM ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2470 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, true,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5068 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2477 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5076 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* FILE: FILE_OP STRING_LIT  */
#line 2482 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 5084 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* LOC: LOC_OP DEC_LIT  */
#line 2487 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5092 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2493 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5101 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2500 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5110 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2507 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 5118 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2513 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 5126 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2519 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5137 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2527 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5148 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2535 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5159 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2543 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5170 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2553 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5178 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2558 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5186 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* NullaryInstruction: YIELD_OP  */
#line 2563 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5194 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2568 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 5202 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2573 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 5210 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2578 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 5218 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2583 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 5226 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* NullaryInstruction: FENCE_SW_OP  */
#line 2588 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 5234 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* OwordModifier: %empty  */
#line 2592 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 5240 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* Predicate: %empty  */
#line 2599 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 5248 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2604 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 5256 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* PredSign: %empty  */
#line 2608 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 5262 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* PredSign: BANG  */
#line 2608 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 5268 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* PredCtrlOpt: %empty  */
#line 2610 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 5274 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* SatModOpt: %empty  */
#line 2613 "CISA.y"
                  {(yyval.sat) = false;}
#line 5280 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* SatModOpt: SAT  */
#line 2613 "CISA.y"
                                      {(yyval.sat) = true;}
#line 5286 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* SrcModifier: SRCMOD_NEG  */
#line 2616 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 5292 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* SrcModifier: SRCMOD_ABS  */
#line 2617 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 5298 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* SrcModifier: SRCMOD_NEGABS  */
#line 2618 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 5304 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* SrcModifier: SRCMOD_NOT  */
#line 2619 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 5310 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* ConditionalModifier: %empty  */
#line 2621 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5316 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* VecDstOperand_A: DstAddrOperand  */
#line 2626 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5322 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* VecDstOperand_G: DstGeneralOperand  */
#line 2627 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5328 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2629 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5334 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2630 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5340 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2635 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5346 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2639 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5352 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2643 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5358 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2644 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5364 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2648 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5370 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2652 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5376 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2653 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5382 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2657 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5388 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2661 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5394 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2663 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5400 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2666 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5412 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2676 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5421 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2683 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5431 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2691 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5441 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2699 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5451 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2730 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5460 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2737 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5468 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2748 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5477 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2753 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5486 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* RawOperandArray: %empty  */
#line 2761 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5494 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2766 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5503 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2774 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5513 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2782 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5522 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* DstGeneralOperand: Var DstRegion  */
#line 2787 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5531 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2793 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5540 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* SrcAddrOfOperand: AddrOfVar  */
#line 2814 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5548 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2818 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5557 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* AddrOfVar: AMP Var  */
#line 2824 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5570 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2835 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5580 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2843 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5590 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2850 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5600 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2860 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5608 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2865 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5618 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* SrcImmOperand: FloatLit  */
#line 2873 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5626 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* SrcImmOperand: MINUS FloatLit  */
#line 2876 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5634 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* SrcImmOperand: DoubleFloatLit  */
#line 2882 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5642 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2886 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5650 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* FloatLit: DEC_LIT FTYPE  */
#line 2893 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5661 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* FloatLit: HEX_LIT FTYPE  */
#line 2900 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5671 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2908 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5682 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2914 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5693 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2925 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5704 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2933 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5715 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2942 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5725 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2960 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5741 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2977 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5755 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2988 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5767 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 401: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2998 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5776 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 402: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 3003 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5785 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 3008 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5796 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* PredVar: Var  */
#line 3016 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5808 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 3025 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5823 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 3037 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5838 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* SIMDMode: %empty  */
#line 3051 "CISA.y"
           {(yyval.intval) = 0;}
#line 5844 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 3054 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5854 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* ElemNum: DOT DEC_LIT  */
#line 3065 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5862 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 3077 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5871 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 3083 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5882 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* ExecSizeInt: DEC_LIT  */
#line 3091 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5893 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 3105 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5899 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 3108 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5905 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 3111 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5911 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 3114 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5917 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 3117 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5923 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 3118 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5929 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 3121 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5935 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 3122 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5941 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 431: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 3123 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5947 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 432: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 3124 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5953 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 435: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 3147 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5959 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 436: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 3148 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5965 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 437: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 3149 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5971 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 439: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 3152 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5977 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 3153 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5983 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 442: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 3156 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5989 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 443: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 3157 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5999 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 444: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 3162 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 6009 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 446: /* IntExpUnr: MINUS IntExpUnr  */
#line 3169 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 6015 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 447: /* IntExpUnr: TILDE IntExpUnr  */
#line 3170 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 6021 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 448: /* IntExpUnr: BANG IntExpUnr  */
#line 3171 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 6027 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 452: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 3179 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 6033 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 453: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 3183 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 6042 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 454: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 3187 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 6052 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 455: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 3193 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 6063 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 463: /* BuildOptions: BUILD_OPTION_LINE  */
#line 3213 "CISA.y"
    {
        pBuilder->CISA_parse_build_options((yyvsp[0].string));
    }
#line 6071 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 6075 "/builddir/build/BUILD/intel-igc-2.7.8-build/intel-graphics-compiler-2.7.8/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3218 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
